// ================================================================
//  ȻCCDOS97ʽ: FLOAT.C
//  (ַ)
//
//  Copyright (c) 1997,1998 Ȼʵ ½
//  Tel: (010)68744479,68744489-207, 01381290625
//  Email: jnchen@iname.com, chenus@public.bta.net.cn
//  Internet: http://www.nease.net/~jnchen
// ----------------------------------------------------------------

// ================================================================
//  	Format:
//  	1.	1234567890
//  	2.  1.23456789
//  	2.  .123456789
//  	3.  1.2345E+67
//  	4.  1.2345E-67
// ----------------------------------------------------------------
double str2double(char *str)
{
	double		duTmp, duDot;
	int 		inDot, iExp, iSym, uExp;

	duTmp = 0;  iExp = iSym = uExp = 0;
	inDot = 0;
	if (*str == '-') {
		iSym = 1;  str ++;
	}
	while (*str) {
		if (*str == '.') {
			inDot = 1;  duDot = (double)0.1;
		}
		else {
			if (*str >= '0' && *str <= '9') {
				if (! inDot) {
					duTmp *= 10.0;
					duTmp += (double)(*str - '0');
				}
				else {
					duTmp += duDot * (double)(*str - '0');
					duDot /= 10.0;
				}
			}
			else
			if (*str == 'E') {
				iExp = 1;
				str ++;
				if (*str == '-' || *str == '+') {
					if (*str == '-') iExp = -1;
					str ++;
				}
				if (*str >= '0' && *str <= '9')
					uExp += iExp * (*str - '0');
				else {
					error = TRUE;  return 0;
				}
				if (*(str+1)) {
					str ++;
					if (*str >= '0' && *str <= '9') {
						uExp *= 10.0;
						uExp += iExp * (*str - '0');
						if (*(str+1)) {
							error = TRUE;  return 0;
						}
					}
				}
			}
			else {
				error = TRUE;  return 0;
			}
		}
		str ++;
	}
	if (uExp != 0)
		duTmp *= pow(10.0, uExp);
	if (iSym) duTmp = -duTmp;
	return duTmp;
}

// ================================================================
//  	Format:
//  	1.  123   0x7B   7Bh  01111011b   '{'
//  	2.	1234567890   0x89ABCDEF   089ABCDEFh   01010011111b
//  	3.  1.23456789
//  	4.  1.2345E+67
//  	5.  1.2345E-67
// ----------------------------------------------------------------

void double2str(double duStr)
{
	double		duInt;
	long		dwInt;
	int 		i, bLen, iExp;
	char		ch, szBit[3];

	if (error != FALSE) {
		strcpy(szDec10, "ʽ!");
		return;
	}
	szBit[1] = '\0';
	if (duStr == (long)duStr) {
		//  1.  123   0x7B   7Bh  01111011b   '{'
		//  2.	1234567890   0x89ABCDEF   089ABCDEFh   01010011111b
		//
		dwInt = (long)duStr;
		bSame = 4;

		ltoa(dwInt, szHex16x+2, 16);  strupr(szHex16x+2);
		if (*(szHex16x+2) > '9') {
			*szHex16 = '0';  strcpy(szHex16+1, szHex16x+2);
		}
		else  strcpy(szHex16, szHex16x+2);
		strcat(szHex16, "h");

		ch = (char)dwInt;
		if ((unsigned long)dwInt < 0xFF &&
			ch > 0 && (ch < 0x07 || ch > 0x09) &&
			ch != 0x0D && ch != 0x0A && ch != 0x1B) {	// dwInt >= 0x20) {
			szAscii[1] = dwInt;  bSame ++;
		}
		ltoa(dwInt, szDec10, 2);
		bLen = (bSame == 4 && dwInt >= 0x20) ?
				((dwInt & 0xFFFF0000) ? 32 : 16) : 8;
		bLen -= strlen(szDec10);
		for (i = 0; i < bLen; i ++)  szBin02[i] = '0';
		strcpy(szBin02+i, szDec10);
		strcat(szBin02, "b");

		ltoa(dwInt, szDec10, 10);
	}
	else {
		bSame = 1;  iExp = 0;
		if (duStr < 0) strcpy(szDec10, "-");
		else  szDec10[0] = '\0';
		duStr = fabs(duStr);

		if (duStr > 1.0e8) {
			duInt = 10.0;
			while (duStr >= duInt) {
				iExp ++;  duStr /= duInt;
			}
		}
		else
		if (duStr < 1.0e-4) {
			duInt = 10.0;
			while (duStr < 1.0) {
				iExp --;  duStr *= duInt;
			}
		}
		duInt = 5.0 / pow10(bPrecision+1);
		duStr += duInt;	// 5.0e-13;				// Adapts precision

		//  3.  1.23456789
		//  4.  1.2345E+67
		//  5.  1.2345E-67

		//	printf("double=%g\n", duStr);
		duInt = 1.0e10;
		while (duStr < duInt) duInt /= 10;
		if (duStr >= 1.0) {
			while (duStr >= 1.0) {
			#ifdef	eDEBUG
				printf("double=%g, [%g]\n", duStr, duInt);
			#endif
				bLen = (int)(duStr / duInt);
				szBit[0] = bLen + '0';
				strcat(szDec10, szBit);
				duStr -= bLen * duInt;
				duInt /= 10;
			}
			while (duInt >= 1.0) {
				duInt /= 10;  strcat(szDec10, "0");
			}
		}
		else
			strcat(szDec10, "0");

		//	printf("double=%g\n", duStr);
		strcat(szDec10, ".");
		duInt = 0.1;
		for (i = 0; i < bPrecision; i ++) {
		#ifdef	eDEBUG
			printf("str=[%s], double=%g, [%g]\n", szDec10, duStr, duInt);
		#endif
			bLen = (int)(duStr / duInt);
			szBit[0] = bLen + '0';
			strcat(szDec10, szBit);
			duStr -= bLen * duInt;
			duInt /= 10;
		}
		i = strlen(szDec10) - 1;
		while (szDec10[i] == '0' && szDec10[i-1] != '.')
			szDec10[i--] = '\0';
		if (iExp != 0) {
			if (iExp > 0) strcat(szDec10, "e+");
			else  strcat(szDec10, "e");
			itoa(iExp, szBin02, 10);
			strcat(szDec10, szBin02);
		}
	}
}

